/****************************************************************************
** ui.h extension file, included from the uic-generated form implementation.
**
** If you wish to add, delete or rename functions or slots use
** Qt Designer which will update this file, preserving your code. Create an
** init() function in place of a constructor, and a destroy() function in
** place of a destructor.
*****************************************************************************/
/*
Copyright (C) 2004-2005 Amour Hassan

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/

void frmGroup::init()
{
	(statusBar())->hide();

	mdl = 0;

	mnuMain = new QPopupMenu();
	mnuMain->insertItem( "&Add", this, SLOT( on_add_group()),
		0, 0);
	mnuMain->insertItem( "&Delete", this, SLOT( on_del_group()),
		0, 1);
	mnuMain->insertItem( "&Rename", this, SLOT( on_rename_group()),
		0, 2);
	mnuMain->insertItem( "&Change Colour", this, SLOT( on_color_group()),
		0, 3);
	mnuMain->insertItem( "Toggle &Visibility", this,
		SLOT( on_visible_group()), 0, 4);
	mnuMain->insertSeparator();
	mnuMain->insertItem( "Set alpha for faces...", this,
		SLOT( on_set_face_alpha()), 0, 5);
	mnuMain->insertItem( "Set color for faces...", this,
		SLOT( on_set_face_color()), 0, 6);
	mnuMain->insertItem( "Set use color for faces...", this,
		SLOT( on_set_use_color()), 0, 7);
	mnuMain->insertItem( "Unset use color for faces...", this,
		SLOT( on_unset_use_color()), 0, 8);
	mnuMain->insertSeparator();
	mnuMain->insertItem( "Force flat shade for faces...", this,
		SLOT( on_force_flat_shade()), 0, 9);
	mnuMain->insertItem( "Unforce flat shade for faces...", this,
		SLOT( on_force_flat_shade()), 0, 10);

	
}


void frmGroup::destroy()
{
	if( mnuMain) delete mnuMain;
}


void frmGroup::on_group_menu()
{
	const int n = lstGroup->currentItem();
	if( (n < 0) || !(lstGroup->isSelected( n))) {
		for( int i = 1; i <= 10; i++)
			mnuMain->setItemVisible( i, false);

	} else {
		for( int i = 1; i <= 10; i++)
			mnuMain->setItemVisible( i, true);
	}

	mnuMain->exec( QCursor::pos());
}


void frmGroup::on_add_group()
{
	sk3DRomGroup *g = mdl->mdl.add_group( sk3DRomGroup());
	strncpy( g->gname, "Untitled", SK3DROM_GROUP_NAME_MAX_LEN - 1);
	lstGroup->insertItem( g->gname);
	mdl->modified = true;
}

void frmGroup::on_del_group()
{
	const int n = lstGroup->currentItem();
	if( n < 0) return;

	QString s;
	s.sprintf( "Delete group \"%s\"?", mdl->mdl.group[n].gname);
	switch( QMessageBox::warning( this, "Conifrm Delete", s,
		QMessageBox::No,
		QMessageBox::Yes,
		QMessageBox::NoButton)) {
	case QMessageBox::Yes: break;
	default: return;
	}

	mdl->mdl.delete_group( n);
	build_group_list();
	mdl->modified = true;
}

void frmGroup::on_rename_group()
{
	const int n = lstGroup->currentItem();
	if( n < 0) return;
	bool ok;
	QString text = QInputDialog::getText(
		"Rename Group", "Name:", QLineEdit::Normal,
		mdl->mdl.group[n].gname, &ok, this );
	if ( ok && !text.isEmpty() ) {
		strncpy( mdl->mdl.group[n].gname, text.latin1(),
			SK3DROM_GROUP_NAME_MAX_LEN - 1);
		lstGroup->changeItem( text, n);
		mdl->modified = true;
	}
}

void frmGroup::on_color_group()
{
	const int n = lstGroup->currentItem();
	if( n < 0) return;
	unsigned char *col = mdl->mdl.group[n].gcolor;
	QColor c = QColorDialog::getColor(
		QColor( col[0], col[1], col[2]), this);
	if( c.isValid()) {
		col[0] = c.red();
		col[1] = c.green();
		col[2] = c.blue();
		mdl->modified = true;

		on_highlight_group( n);
	}
}

void frmGroup::on_visible_group()
{
	const int n = lstGroup->currentItem();
	if( n < 0) return;

	// Toggle the visiblity of the group.
	if( (mdl->mdl.group[n].hidden())) mdl->mdl.reveal_group( n);
	else mdl->mdl.hide_group( n);

	// Show the group as being visible or hidden.
	if( (mdl->mdl.group[n].hidden())) {
		lstGroup->changeItem(
			gbl_pixmaps[KRN_PIXMAP_ICON_RED_H],
			mdl->mdl.group[n].gname,
			n);
	} else {
		lstGroup->changeItem( mdl->mdl.group[n].gname, n);
	}
	mdl->modified = true;
	mdl->update_all_views();
}


void frmGroup::build_group_list()
{
	lstGroup->clear();
	std::vector <sk3DRomGroup> &g = mdl->mdl.group;
	const int istop = int( mdl->mdl.group.size());
	for( int i = 0; i < istop; i++) {
		if( ((g[i].flags) & SK3DROM_GROUP_HIDDEN_BIT)) {
			lstGroup->insertItem(
				gbl_pixmaps[KRN_PIXMAP_ICON_RED_H],
				g[i].gname);
		} else lstGroup->insertItem( g[i].gname);
	}
}


void frmGroup::on_highlight_group( int n )
{
	if( n >= 0) {
		unsigned char *col = mdl->mdl.group[n].gcolor;
		QColor c( col[0], col[1], col[2]);
		lblColor->setPaletteBackgroundColor( c);
	} else {
		lblColor->setPaletteBackgroundColor(
			paletteBackgroundColor());
	}
}


void frmGroup::on_set_face_alpha()
{
	bool ok;
	const double res = QInputDialog::getDouble(
		"Set face alpha", "Enter alpha value:", 1.0, 0,
		1.0, 6, &ok, this);
	if( !ok) return;
	mdl->mdl.set_alpha_of_face_group(  lstGroup->currentItem(), res);
	mdl->modified = true;
}

void frmGroup::on_set_face_color()
{
	QColor c = QColorDialog::getColor( QColor( 1, 1, 1), this);
	if( !(c.isValid())) return;
	mdl->mdl.set_color_of_face_group( lstGroup->currentItem(),
		float( c.red()) / 255.0f,
		float( c.green()) / 255.0f,
		float( c.blue()) / 255.0f);
	mdl->modified = true;
}

void frmGroup::on_force_flat_shade()
{
	mdl->mdl.force_flat_face_group( lstGroup->currentItem());
	mdl->modified = true;
}


void frmGroup::on_unforce_flat_shade()
{
	mdl->mdl.unforce_flat_face_group( lstGroup->currentItem());
	mdl->modified = true;
}


void frmGroup::on_set_use_color()
{
	mdl->mdl.set_use_color_of_face_group( lstGroup->currentItem());
	mdl->modified = true;
}

void frmGroup::on_unset_use_color()
{
	mdl->mdl.unset_use_color_of_face_group( lstGroup->currentItem());
	mdl->modified = true;
}
