/*
Copyright (C) 2004-2005 Amour Hassan

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/

#ifndef RG3DROM_SUPPORT_H
#define RG3DROM_SUPPORT_H

#include "rg3DRom.h"

int sk3DRom_read_tag( std::istream &inf, sk3DRomTag &t);
int sk3DRom_write_tag( std::fstream &des, sk3DRomTag &t);
int sk3DRom_write_tag( std::ostream &des, sk3DRomTag &t);
int sk3DRom_write_out_pending_tag( std::ostream &des, sk3DRomTag t);

inline bool sup_triangle_is_hidden( const sk3DRomModel &mdl, const int i)
{
	if(     (mdl.v[ mdl.f[i].vid[0]].hidden()) ||
		(mdl.v[ mdl.f[i].vid[1]].hidden()) ||
		(mdl.v[ mdl.f[i].vid[2]].hidden())) return true;
	return false;
}

#endif
