/*
Copyright (C) 2004-2005 Amour Hassan

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/

#include <rgBSP_GRR.h>

template <class T>
rgBSPTree<T>::rgBSPTreeGRR()
{
	root = 0;
	chrf = 0;
}

template <class T>
rgBSPTree<T>::~rgBSPTreeGRR()
{
	clear();
}

template <class T>
void rgBSPTree<T>::clear()
{
	chrf = 0;
	interp = 0;
		
	if( root) { delete [] root; root = 0;}
	if( fdata) { delete [] fdata; fdata = 0;}
	if( fviddata) { delete [] fviddata; fviddata = 0;}
	if( vdata) { delete [] vdata; vdata = 0;}

	fcount = 0;
	fvidcount = 0;
	vcount = 0;
}

template <class T>
int rgBSPTree<T>::gen_GRR_BSP( rgBSPTree &tree, void (*p_interp)( T*, T*, T*,
	const float))
{

	clear();

	if( !p_interp) return -1;
	interp = p_interp;

	// Determine the total number of verticies contained in the
	// BSP tree. This is done by adding all unique verticies to a vertex
	// list.

	return 0;
}

template <class T>
void rgBSPTree<T>::render( rgVector p)
{
}

template <class T>
void rgBSPTree<T>::render( rgVector p, rgBSPNode *node)
{
}

