/*
Copyright (C) 2003-2005 Amour Hassan

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/

#ifndef RGOBJ_H
#define RGOBJ_H

#include <fstream>
#include <vector>
#include <rgStandard.h>

#define RGOBJ_MAX_COMMAND_LENGTH 63
#define RGOBJ_MAX_ERR_MSG_LENGTH 255

class rgOBJVertex : public rgVector
{
public:
	
};

class rgOBJ
{
public:

	bool fail_on_errors;
	char *err_msg;

        std::vector <rgOBJVertex> verts;

	rgOBJ();
	~rgOBJ();

	void clear();
	int load( const char *fname);


private:

};

int get_command( std::ifstream &inf, char *cmd, int &i);
int match_command( char *cmd, const int len);
void end_line( std::ifstream &inf);

#endif
