/*
Copyright (C) 2003-2005 Amour Hassan
                                                                                
This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.
                                                                                
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.
                                                                                
You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
                                                                                
*/

#ifndef RGERROR_H
#define RGERROR_H

#define MAX_ERROR_STRING_LENGTH 256

#define RGERR_SUCCESS 0			/* Success (no error) */
#define RGERR_FAIL -1			/* General failure */
#define RGERR_COULD_NOT_OPEN_FILE -2	/* Could not open file */
#define RGERR_COULD_NOT_FIND_FILE -3	/* Could not find file */
#define RGERR_NO_ALLOC -4		/* Could not allocate memory */
#define RGERR_BAD_PARAM -5		/* Invalid parameter passed */
#define RGERR_READ_FROM_FILE -6		/* Could not read from file */
#define RGERR_WRITE_TO_FILE -7		/* Could not write to file */
#define RGERR_STREAM_BAD -8		/* Stream is bad */
#define RGERR_STREAM_FAILS -9		/* Stream I/O failed */
#define RGERR_EOF -10			/* End of file */

#define RGERR_ISERROR(n) ((n) != RGERR_SUCCESS)

char *rgErrorString( int p_error);
#endif
