/*
Copyright (C) 2004-2005 Amour Hassan
                                                                                
This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.
                                                                                
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.
                                                                                
You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
                                                                                
*/

#include "ai_coach.h"
#include "engine/engine_game.h"
#include <rg3DRom.h>

std::map <const std::string, int (*)( const gmCCArg &)> phAI_Coach::m_ccmd;

extern "C" gmThing *spw_phAI_Coach()
{
	return new phAI_Coach();
}

extern "C" int del_phAI_Coach( gmThing *t)
{
	delete t;
	return 0;
}

RPH_THING_MODULE_MAIN_FUNCTION( phAI_Coach)
{
	p_ge->m_thing_manager->add_to_spawn_list( "phAI_Coach",
		spw_phAI_Coach);

	p_ge->m_thing_manager->add_to_delete_list( "phAI_Coach",
		del_phAI_Coach);

	return 0;
}

phAI_Coach::phAI_Coach()
{

	if( !(m_ccmd.empty())) return;
}

phAI_Coach::~phAI_Coach()
{
}

int phAI_Coach::call_ccmd( const std::string &key, gmCCArg &args)
{
	std::map <const std::string, int (*)( const gmCCArg &)> ::
		const_iterator iter = m_ccmd.find( key);
	if( iter == m_ccmd.end()) return phAI::call_ccmd( key, args);
	return (iter->second)( args);
}

std::string phAI_Coach::list_ccmd( const std::string &p_prefix)
{
	std::map <const std::string, int (*)( const gmCCArg &)> ::
		const_iterator iter = m_ccmd.begin();
	std::string tmp;
	for( ; iter != m_ccmd.end(); iter++) {
		tmp += p_prefix + phAI_Coach::type() + "::" + (iter->first) +
			"\n";
	}
	tmp += phAI::list_ccmd( p_prefix);
	return tmp;
}


void phAI_Coach::process( ThingManager *tm)
{
	//std::cout << "Coach \"" + (tcb())->m_key + "\" is thinking\n";
}
