/*
Copyright (C) 2004-2005 Amour Hassan

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/

#ifndef REFEREE_H
#define REFEREE_H

#include "player.h"

class phReferee : public phPerson
{
public:
	RPH_THING_MODULE

	phReferee();
	virtual ~phReferee();

	void process( ThingManager *tm);

	std::string type() const { return std::string( "phReferee");}
	bool is_a( const std::string &s) const {
		if( s != phReferee::type()) return phPerson::is_a( s);
		return true;
	}

	int call_ccmd( const std::string &key, gmCCArg &args);
	std::string list_ccmd( const std::string &p_prefix);

	void draw( gmRenderArgs *ra);

protected:
	static std::map <const std::string, int (*)( const gmCCArg &)> m_ccmd;

private:
	phReferee( const phReferee &);
	phReferee &operator =( const phReferee &);
};

#endif
